/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.86 Revision 1.122
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.86 2010/11/13 20:30:26 wired Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.122 2012/03/01 15:19:14 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 12inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16 13
17MY_PV=${PV/_/-} 14MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 15MY_P=qt-everywhere-opensource-src-${MY_PV}
16
17HOMEPAGE="http://qt.nokia.com/ http://qt-project.org/"
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )"
20
21IUSE="aqua debug pch"
22
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] &&
21 [[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] && 24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
22 IUSE="+exceptions" 25 IUSE+=" +exceptions"
23else 26
24 MY_P=qt-x11-opensource-src-${MY_PV} 27if version_is_at_least 4.7.99999999; then
28 IUSE+=" c++0x qpa"
25fi 29fi
26 30
27HOMEPAGE="http://qt.nokia.com/" 31DEPEND="dev-util/pkgconfig"
28SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
29
30LICENSE="|| ( LGPL-2.1 GPL-3 )"
31IUSE+=" debug"
32[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
33 IUSE+=" pch aqua"
34
35RDEPEND=" 32RDEPEND="
36 !<x11-libs/qt-assistant-${PV} 33 !<x11-libs/qt-assistant-${PV}
37 !>x11-libs/qt-assistant-${PV}-r9999 34 !>x11-libs/qt-assistant-${PV}-r9999
38 !<x11-libs/qt-core-${PV} 35 !<x11-libs/qt-core-${PV}
39 !>x11-libs/qt-core-${PV}-r9999 36 !>x11-libs/qt-core-${PV}-r9999
40 !<x11-libs/qt-dbus-${PV} 37 !<x11-libs/qt-dbus-${PV}
41 !>x11-libs/qt-dbus-${PV}-r9999 38 !>x11-libs/qt-dbus-${PV}-r9999
39 !<x11-libs/qt-declarative-${PV}
40 !>x11-libs/qt-declarative-${PV}-r9999
42 !<x11-libs/qt-demo-${PV} 41 !<x11-libs/qt-demo-${PV}
43 !>x11-libs/qt-demo-${PV}-r9999 42 !>x11-libs/qt-demo-${PV}-r9999
44 !<x11-libs/qt-gui-${PV} 43 !<x11-libs/qt-gui-${PV}
45 !>x11-libs/qt-gui-${PV}-r9999 44 !>x11-libs/qt-gui-${PV}-r9999
46 !<x11-libs/qt-multimedia-${PV} 45 !<x11-libs/qt-multimedia-${PV}
47 !>x11-libs/qt-multimedia-${PV}-r9999 46 !>x11-libs/qt-multimedia-${PV}-r9999
48 !<x11-libs/qt-opengl-${PV} 47 !<x11-libs/qt-opengl-${PV}
49 !>x11-libs/qt-opengl-${PV}-r9999 48 !>x11-libs/qt-opengl-${PV}-r9999
49 !<x11-libs/qt-openvg-${PV}
50 !>x11-libs/qt-openvg-${PV}-r9999
50 !<x11-libs/qt-phonon-${PV} 51 !<x11-libs/qt-phonon-${PV}
51 !>x11-libs/qt-phonon-${PV}-r9999 52 !>x11-libs/qt-phonon-${PV}-r9999
52 !<x11-libs/qt-qt3support-${PV} 53 !<x11-libs/qt-qt3support-${PV}
53 !>x11-libs/qt-qt3support-${PV}-r9999 54 !>x11-libs/qt-qt3support-${PV}-r9999
54 !<x11-libs/qt-script-${PV} 55 !<x11-libs/qt-script-${PV}
67 68
68S=${WORKDIR}/${MY_P} 69S=${WORKDIR}/${MY_P}
69 70
70# @FUNCTION: qt4-build_pkg_setup 71# @FUNCTION: qt4-build_pkg_setup
71# @DESCRIPTION: 72# @DESCRIPTION:
72# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 73# Sets up PATH and LD_LIBRARY_PATH.
73qt4-build_pkg_setup() { 74qt4-build_pkg_setup() {
74 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 75 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
75 76
76 # Protect users by not allowing downgrades between releases 77 # Protect users by not allowing downgrades between releases
77 # Downgrading revisions within the same release should be allowed 78 # Downgrading revisions within the same release should be allowed
78 if has_version '>'${CATEGORY}/${P}-r9999 ; then 79 if has_version '>'${CATEGORY}/${P}-r9999; then
79 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 80 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
80 eerror "Sanity check to keep you from breaking your system:" 81 eerror "Sanity check to keep you from breaking your system:"
81 eerror " Downgrading Qt is completely unsupported and will break your system!" 82 eerror " Downgrading Qt is completely unsupported and will break your system!"
82 die "aborting to save your system" 83 die "aborting to save your system"
83 else 84 else
84 ewarn "Downgrading Qt is completely unsupported and will break your system!" 85 ewarn "Downgrading Qt is completely unsupported and will break your system!"
85 fi 86 fi
86 fi 87 fi
87 88
88 if [[ "${PN}" == "qt-webkit" ]]; then 89 if [[ ${PN} == "qt-webkit" ]]; then
89 eshopts_push -s extglob 90 eshopts_push -s extglob
90 if is-flagq '-g?(gdb)?([1-9])'; then 91 if is-flagq '-g?(gdb)?([1-9])'; then
91 echo 92 echo
92 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)." 93 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
93 ewarn "You may experience really long compilation times and/or increased memory usage." 94 ewarn "You may experience really long compilation times and/or increased memory usage."
110 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 111 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
111 ${QT4_EXTRACT_DIRECTORIES}" 112 ${QT4_EXTRACT_DIRECTORIES}"
112 fi 113 fi
113 114
114 # Make sure ebuilds use the required EAPI 115 # Make sure ebuilds use the required EAPI
115 if [[ ${EAPI} != [23] ]]; then 116 if [[ ${EAPI} != [234] ]]; then
116 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using" 117 eerror "The qt4-build eclass requires EAPI 2,3 or 4 but this ebuild is using"
117 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be" 118 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
118 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail." 119 eerror "fixed. Using qt4-build eclass without EAPI 2,3 or 4 will fail."
119 die "qt4-build eclass requires EAPI=2 or EAPI=3" 120 die "qt4-build eclass requires EAPI 2,3 or 4"
120 fi 121 fi
121 122
122 if ! version_is_at_least 4.1 $(gcc-version); then 123 if ! version_is_at_least 4.1 $(gcc-version); then
123 ewarn "Using a GCC version lower than 4.1 is not supported!" 124 ewarn "Using a GCC version lower than 4.1 is not supported!"
124 fi 125 fi
125} 126}
126 127
127# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 128# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
128# @DESCRIPTION: 129# @DESCRIPTION:
129# Arguments for build_target_directories. Takes the directories, in which the 130# Arguments for build_target_directories. Takes the directories in which the
130# code should be compiled. This is a space-separated list 131# code should be compiled. This is a space-separated list.
131 132
132# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 133# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
133# @DESCRIPTION: 134# @DESCRIPTION:
134# Space separated list including the directories that will be extracted from Qt 135# Space-separated list including the directories that will be extracted from
135# tarball 136# Qt tarball.
136 137
137# @FUNCTION: qt4-build_src_unpack 138# @FUNCTION: qt4-build_src_unpack
138# @DESCRIPTION: 139# @DESCRIPTION:
139# Unpacks the sources 140# Unpacks the sources.
140qt4-build_src_unpack() { 141qt4-build_src_unpack() {
141 setqtenv 142 setqtenv
142 local target targets= 143
144 local tarball="${MY_P}.tar.gz" target= targets=
143 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 145 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
144 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 146 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
145 ${QT4_EXTRACT_DIRECTORIES}; do 147 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
148 do
146 targets+=" ${MY_P}/${target}" 149 targets+="${MY_P}/${target} "
147 done 150 done
148 151
152 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
149 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 153 tar -xzf "${DISTDIR}/${tarball}" ${targets}
150 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 154 eend $? || die "failed to unpack"
151} 155}
152 156
153# @ECLASS-VARIABLE: PATCHES 157# @ECLASS-VARIABLE: PATCHES
158# @DEFAULT_UNSET
154# @DESCRIPTION: 159# @DESCRIPTION:
155# In case you have patches to apply, specify them in PATCHES variable. Make sure 160# PATCHES array variable containing all various patches to be applied.
156# to specify the full path. This variable is necessary for src_prepare phase. 161# This variable is expected to be defined in global scope of ebuild.
157# example: 162# Make sure to specify the full path. This variable is utilised in
158# PATCHES="${FILESDIR}"/mypatch.patch 163# src_unpack/src_prepare phase, based on EAPI.
159# ${FILESDIR}"/mypatch2.patch"
160# 164#
165# @CODE
166# PATCHES=( "${FILESDIR}/mypatch.patch"
167# "${FILESDIR}/patches_folder/" )
168# @CODE
161 169
162# @FUNCTION: qt4-build_src_prepare 170# @FUNCTION: qt4-build_src_prepare
163# @DESCRIPTION: 171# @DESCRIPTION:
164# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 172# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
165# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 173# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
166qt4-build_src_prepare() { 174qt4-build_src_prepare() {
167 setqtenv 175 setqtenv
168 cd "${S}" 176 cd "${S}"
169 177
170 # fix qt 4.7 regression that skips -fvisibility=hidden
171 if version_is_at_least "4.7.0_beta1"; then 178 if version_is_at_least "4.7"; then
172 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
173 -i config.tests/unix/fvisibility.test ||
174 die "visibility fixing sed failed"
175 fi
176 # fix libx11 dependency on non X packages 179 # fix libX11 dependency on non X packages
177 if version_is_at_least "4.7.0_beta2"; then
178 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 180 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
179 hasq ${PN} ${NOLIBX11PKG} && qt_nolibx11 181 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
180 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup 182
183 qt_assistant_cleanup
181 fi 184 fi
182 185
183 if use aqua; then 186 if use aqua; then
184 # provide a proper macx-g++-64 187 # provide a proper macx-g++-64
185 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 188 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
186 189
187 sed -e '/^CONFIG/s:app_bundle::' \ 190 sed -e '/^CONFIG/s:app_bundle::' \
188 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 191 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
189 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 192 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
190 fi 193 fi
191 194
192 if [[ ${PN} != qt-core ]]; then 195 if [[ ${PN} != qt-core ]]; then
193 skip_qmake_build_patch 196 skip_qmake_build
194 skip_project_generation_patch 197 skip_project_generation
195 symlink_binaries_to_buildtree 198 symlink_binaries_to_buildtree
196 fi 199 fi
197 200
198 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 201 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
199 # qmake bus errors with -O2 but -O3 works 202 # qmake bus errors with -O2 but -O3 works
200 replace-flags -O2 -O3 203 replace-flags -O2 -O3
201 fi 204 fi
202 205
203 # Bug 178652 206 # Bug 178652
204 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 207 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
205 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 208 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
206 append-flags -fno-gcse 209 append-flags -fno-gcse
207 fi 210 fi
208 211
212 if use_if_iuse c++0x; then
213 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
214 ewarn "this is an official standard, some of the reverse dependencies"
215 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
216 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
217 ewarn "disabled."
218 append-flags -std=c++0x
219 fi
220
209 # Unsupported old gcc versions - hardened needs this :( 221 # Unsupported old gcc versions - hardened needs this :(
210 if [[ $(gcc-major-version) -lt 4 ]] ; then 222 if [[ $(gcc-major-version) -lt 4 ]]; then
211 ewarn "Appending -fno-stack-protector to CXXFLAGS" 223 ewarn "Appending -fno-stack-protector to CXXFLAGS"
212 append-cxxflags -fno-stack-protector 224 append-cxxflags -fno-stack-protector
213 # Bug 253127 225 # Bug 253127
214 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 226 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
215 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 227 -i mkspecs/common/g++.conf || die
216 fi 228 fi
217 229
218 # Bug 261632 230 # Bug 261632
219 if use ppc64; then 231 if use ppc64; then
220 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 232 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
221 append-flags -mminimal-toc 233 append-flags -mminimal-toc
222 fi 234 fi
223 235
224 # Bug 282984 && Bug 295530 236 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
225 sed -e "s:\(^SYSTEM_VARIABLES\):CC="$(tc-getCC)"\nCXX="$(tc-getCXX)"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 237 sed -e "/^SYSTEM_VARIABLES=/i \
226 -i configure || die "sed qmake compilers failed" 238 CC='$(tc-getCC)'\n\
227 # bug 321335 239 CXX='$(tc-getCXX)'\n\
228 if version_is_at_least 4.6; then 240 CFLAGS='${CFLAGS}'\n\
229 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 241 CXXFLAGS='${CXXFLAGS}'\n\
230 xargs -0 \ 242 LDFLAGS='${LDFLAGS}'\n" \
231 sed -e "s:\(\$MAKE\):\1 CC="$(tc-getCC)" CXX="$(tc-getCXX)" LD="$(tc-getCXX)" LINK="$(tc-getCXX)":g" \ 243 -i configure \
232 -i || die "sed test compilers failed" 244 || die "sed SYSTEM_VARIABLES failed"
233 fi 245
246 # Respect CC, CXX, LINK and *FLAGS in config.tests
247 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
248 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
249 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
250 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
251 || die "sed config.tests failed"
252
253 # Strip predefined CFLAGS from mkspecs (bug 312689)
254 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
234 255
235 # Bug 172219 256 # Bug 172219
236 sed -e "s:X11R6/::" \ 257 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
237 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
238 258
239 if [[ ${CHOST} == *-darwin* ]]; then 259 if [[ ${CHOST} == *-darwin* ]]; then
240 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 260 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
241 # crippled (by design) :/ 261 # crippled (by design) :/
262 sed \
242 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 263 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
243 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 264 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
244 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 265 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
245 -e "s:-arch\s\w*::g" \ 266 -e "s:-arch\s\w*::g" \
246 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 267 -i mkspecs/common/mac-g++.conf \
268 || die "sed mkspecs/common/mac-g++.conf failed"
247 269
248 # Fix configure's -arch settings that appear in qmake/Makefile and also 270 # Fix configure's -arch settings that appear in qmake/Makefile and also
249 # fix arch handling (automagically duplicates our -arch arg and breaks 271 # fix arch handling (automagically duplicates our -arch arg and breaks
250 # pch). Additionally disable Xarch support. 272 # pch). Additionally disable Xarch support.
251 sed \ 273 sed \
256 -e "s:-arch \$i::" \ 278 -e "s:-arch \$i::" \
257 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
258 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
259 -e "s:-Xarch_x86_64::g" \ 281 -e "s:-Xarch_x86_64::g" \
260 -e "s:-Xarch_ppc64::g" \ 282 -e "s:-Xarch_ppc64::g" \
261 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 283 -i configure mkspecs/common/mac-g++.conf \
284 || die "sed -arch/-Xarch failed"
262 285
263 # On Snow Leopard don't fall back to 10.5 deployment target. 286 # On Snow Leopard don't fall back to 10.5 deployment target.
264 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 287 if [[ ${CHOST} == *-apple-darwin10 ]]; then
265 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 288 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
266 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 289 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
267 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 290 -i configure mkspecs/common/mac-g++.conf \
291 || die "sed deployment target failed"
268 fi 292 fi
269 fi 293 fi
270 294
271 # this one is needed for all systems with a separate -liconv, apart from 295 # this one is needed for all systems with a separate -liconv, apart from
272 # Darwin, for which the sources already cater for -liconv 296 # Darwin, for which the sources already cater for -liconv
273 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 297 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
274 sed \ 298 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
275 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
276 -i config.tests/unix/iconv/iconv.pro \ 299 -i config.tests/unix/iconv/iconv.pro \
277 || die "sed on iconv.pro failed" 300 || die "sed iconv.pro failed"
278 fi 301 fi
279 302
280 # we need some patches for Solaris 303 # we need some patches for Solaris
281 sed -i \
282 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 304 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
283 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
284 # use GCC over SunStudio 306 # use GCC over SunStudio
285 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
286 # don't flirt with non-Prefix stuff, we're quite possessive 308 # do not flirt with non-Prefix stuff, we're quite possessive
287 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
288 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
289 # strip predefined CFLAGS from qmake ( bug #312689 )
290 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
291 311
292 base_src_prepare 312 base_src_prepare
293} 313}
294 314
295# @FUNCTION: qt4-build_src_configure 315# @FUNCTION: qt4-build_src_configure
296# @DESCRIPTION: 316# @DESCRIPTION:
297# Default configure phase 317# Default configure phase
298qt4-build_src_configure() { 318qt4-build_src_configure() {
299 setqtenv 319 setqtenv
300 myconf="$(standard_configure_options) ${myconf}" 320
321 local conf="
322 -prefix ${QTPREFIXDIR}
323 -bindir ${QTBINDIR}
324 -libdir ${QTLIBDIR}
325 -docdir ${QTDOCDIR}
326 -headerdir ${QTHEADERDIR}
327 -plugindir ${QTPLUGINDIR}
328 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
329 -datadir ${QTDATADIR}
330 -translationdir ${QTTRANSDIR}
331 -sysconfdir ${QTSYSCONFDIR}
332 -examplesdir ${QTEXAMPLESDIR}
333 -demosdir ${QTDEMOSDIR}
334 -opensource -confirm-license
335 -shared -fast -largefile -stl -verbose
336 -nomake examples -nomake demos"
337
338 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
339 # $(tc-arch). Therefore we convert it to supported values.
340 case "$(tc-arch)" in
341 amd64|x64-*) conf+=" -arch x86_64" ;;
342 ppc-macos) conf+=" -arch ppc" ;;
343 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
344 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
345 x86-macos) conf+=" -arch x86" ;;
346 x86|x86-*) conf+=" -arch i386" ;;
347 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
348 hppa|sh) conf+=" -arch generic" ;;
349 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
350 esac
351
352 conf+=" -platform $(qt_mkspecs_dir)"
353
354 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
355
356 # debug/release
357 if use debug; then
358 conf+=" -debug"
359 else
360 conf+=" -release"
361 fi
362 conf+=" -no-separate-debug-info"
363
364 # exceptions USE flag
365 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
366
367 # disable RPATH on Qt >= 4.8 (bug 380415)
368 version_is_at_least 4.8 && conf+=" -no-rpath"
369
370 # precompiled headers don't work on hardened, where the flag is masked
371 conf+=" $(qt_use pch)"
372
373 # -reduce-relocations
374 # This flag seems to introduce major breakage to applications,
375 # mostly to be seen as a core dump with the message "QPixmap: Must
376 # construct a QApplication before a QPaintDevice" on Solaris.
377 # -- Daniel Vergien
378 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
301 379
302 # this one is needed for all systems with a separate -liconv, apart from 380 # this one is needed for all systems with a separate -liconv, apart from
303 # Darwin, for which the sources already cater for -liconv 381 # Darwin, for which the sources already cater for -liconv
304 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 382 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
305 myconf+=" -liconv" 383 conf+=" -liconv"
384 fi
306 385
307 if has glib ${IUSE//+} && use glib; then 386 if use_if_iuse glib; then
308 # use -I, -L and -l from configure
309 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 387 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
310 # avoid the -pthread argument 388 # avoid the -pthread argument
311 myconf+=" ${glibflags//-pthread}" 389 conf+=" ${glibflags//-pthread}"
312 unset glibflags 390 unset glibflags
313 fi 391 fi
314 392
393 if use_if_iuse qpa; then
394 ewarn
395 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
396 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
397 ewarn "disable it before reporting any bugs related to this useflag."
398 ewarn
399 conf+=" -qpa"
400 fi
401
315 if use aqua ; then 402 if use aqua; then
316 # On (snow) leopard use the new (frameworked) cocoa code. 403 # On (snow) leopard use the new (frameworked) cocoa code.
317 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 404 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
318 myconf+=" -cocoa -framework" 405 conf+=" -cocoa -framework"
406 # We need the source's headers, not the installed ones.
407 conf+=" -I${S}/include"
408 # Add hint for the framework location.
409 conf+=" -F${QTLIBDIR}"
319 410
320 # We are crazy and build cocoa + qt3support :-) 411 # We are crazy and build cocoa + qt3support :-)
321 if use qt3support; then 412 if use qt3support; then
322 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 413 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
323 -i configure 414 -i configure || die
324 fi 415 fi
325 416 else
326 # We need the source's headers, not the installed ones. 417 conf+=" -no-framework"
327 myconf+=" -I${S}/include"
328
329 # Add hint for the framework location.
330 myconf+=" -F${QTLIBDIR}"
331 fi 418 fi
332 else 419 else
333 # freetype2 include dir is non-standard, thus include it on configure 420 # freetype2 include dir is non-standard, thus pass it to configure
334 # use -I from configure
335 myconf+=" $(pkg-config --cflags freetype2)" 421 conf+=" $(pkg-config --cflags-only-I freetype2)"
336 fi 422 fi
337 423
338 # Disable SSE4.x, since auto-detection is currently broken 424 conf+=" ${myconf}"
339 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 425 myconf=
340 if version_is_at_least 4.7.1; then
341 myconf+=" -no-sse4.1 -no-sse4.2"
342 fi
343 426
344 echo ./configure ${myconf} 427 echo ./configure ${conf}
345 ./configure ${myconf} || die "./configure failed" 428 ./configure ${conf} || die "./configure failed"
346 myconf="" 429
430 prepare_directories ${QT4_TARGET_DIRECTORIES}
347} 431}
348 432
349# @FUNCTION: qt4-build_src_compile 433# @FUNCTION: qt4-build_src_compile
434# @DESCRIPTION:
350# @DESCRIPTION: Actual compile phase 435# Actual compile phase
351qt4-build_src_compile() { 436qt4-build_src_compile() {
352 setqtenv 437 setqtenv
353 438
354 build_directories ${QT4_TARGET_DIRECTORIES} 439 build_directories ${QT4_TARGET_DIRECTORIES}
355} 440}
356 441
357# @FUNCTION: qt4-build_src_test 442# @FUNCTION: qt4-build_src_test
358# @DESCRIPTION: 443# @DESCRIPTION:
359# Runs tests only in target directories. 444# Runs tests only in target directories.
360qt4-build_src_test() { 445qt4-build_src_test() {
446 # QtMultimedia does not have any test suite (bug #332299)
447 [[ ${PN} == "qt-multimedia" ]] && return
448
361 for dir in ${QT4_TARGET_DIRECTORIES}; do 449 for dir in ${QT4_TARGET_DIRECTORIES}; do
362 emake -j1 check -C ${dir} 450 emake -j1 check -C ${dir}
363 done 451 done
364} 452}
365 453
366# @FUNCTION: fix_includes 454# @FUNCTION: fix_includes
367# @DESCRIPTION: 455# @DESCRIPTION:
368# For MacOSX we need to add some symlinks when frameworks are 456# For MacOS X we need to add some symlinks when frameworks are
369# being used, to avoid complications with some more or less stupid packages. 457# being used, to avoid complications with some more or less stupid packages.
370fix_includes() { 458fix_includes() {
371 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 459 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
372 # Some packages tend to include <Qt/...> 460 # Some packages tend to include <Qt/...>
373 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 461 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
374 462
375 # Fake normal headers when frameworks are installed... eases life later on 463 # Fake normal headers when frameworks are installed... eases life later on
376 local dest f 464 local dest f h
377 for frw in "${D}${QTLIBDIR}"/*.framework; do 465 for frw in "${D}${QTLIBDIR}"/*.framework; do
378 [[ -e "${frw}"/Headers ]] || continue 466 [[ -e "${frw}"/Headers ]] || continue
379 f=$(basename ${frw}) 467 f=$(basename ${frw})
380 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 468 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
381 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 469 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
393# @DESCRIPTION: 481# @DESCRIPTION:
394# Perform the actual installation including some library fixes. 482# Perform the actual installation including some library fixes.
395qt4-build_src_install() { 483qt4-build_src_install() {
396 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 484 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
397 setqtenv 485 setqtenv
486
398 install_directories ${QT4_TARGET_DIRECTORIES} 487 install_directories ${QT4_TARGET_DIRECTORIES}
399 install_qconfigs 488 install_qconfigs
400 fix_library_files 489 fix_library_files
401 fix_includes 490 fix_includes
491
402 # remove .la files since we are building only shared Qt libraries 492 # remove .la files since we are building only shared Qt libraries
403 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 493 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
404} 494}
405 495
406# @FUNCTION: setqtenv 496# @FUNCTION: setqtenv
497# @INTERNAL
407setqtenv() { 498setqtenv() {
408 # Set up installation directories 499 # Set up installation directories
409 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
410 QTPREFIXDIR=${EPREFIX}/usr 500 QTPREFIXDIR=${EPREFIX}/usr
411 QTBINDIR=${EPREFIX}/usr/bin 501 QTBINDIR=${EPREFIX}/usr/bin
412 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 502 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
413 QMAKE_LIBDIR_QT=${QTLIBDIR}
414 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 503 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
415 QTDATADIR=${EPREFIX}/usr/share/qt4
416 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 504 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
417 QTHEADERDIR=${EPREFIX}/usr/include/qt4 505 QTHEADERDIR=${EPREFIX}/usr/include/qt4
418 QTPLUGINDIR=${QTLIBDIR}/plugins 506 QTPLUGINDIR=${QTLIBDIR}/plugins
507 QTIMPORTDIR=${QTLIBDIR}/imports
508 QTDATADIR=${EPREFIX}/usr/share/qt4
509 QTTRANSDIR=${QTDATADIR}/translations
419 QTSYSCONFDIR=${EPREFIX}/etc/qt4 510 QTSYSCONFDIR=${EPREFIX}/etc/qt4
420 QTTRANSDIR=${QTDATADIR}/translations
421 QTEXAMPLESDIR=${QTDATADIR}/examples 511 QTEXAMPLESDIR=${QTDATADIR}/examples
422 QTDEMOSDIR=${QTDATADIR}/demos 512 QTDEMOSDIR=${QTDATADIR}/demos
513 QMAKE_LIBDIR_QT=${QTLIBDIR}
423 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 514 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
515
424 PLATFORM=$(qt_mkspecs_dir) 516 PLATFORM=$(qt_mkspecs_dir)
425 517
426 unset QMAKESPEC 518 unset QMAKESPEC
427} 519}
428 520
429# @FUNCTION: standard_configure_options
430# @DESCRIPTION:
431# Sets up some standard configure options, like libdir (if necessary), whether
432# debug info is wanted or not.
433standard_configure_options() {
434 local myconf=
435
436 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
437
438 # Disable visibility explicitly if gcc version isn't 4
439 if [[ $(gcc-major-version) -lt 4 ]]; then
440 myconf+=" -no-reduce-exports"
441 fi
442
443 # precompiled headers doesn't work on hardened, where the flag is masked.
444 myconf+=" $(qt_use pch)"
445
446 if use debug; then
447 myconf+=" -debug"
448 else
449 myconf+=" -release"
450 fi
451 myconf+=" -no-separate-debug-info"
452
453 use aqua && myconf+=" -no-framework"
454
455 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
456 # $(tc-arch). Therefore we convert it to supported values.
457 case "$(tc-arch)" in
458 amd64|x64-*) myconf+=" -arch x86_64" ;;
459 ppc-macos) myconf+=" -arch ppc" ;;
460 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
461 sparc|sparc-*) myconf+=" -arch sparc" ;;
462 x86-macos) myconf+=" -arch x86" ;;
463 x86|x86-*) myconf+=" -arch i386" ;;
464 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
465 hppa|sh) myconf+=" -arch generic" ;;
466 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
467 esac
468
469 # 4.5: build everything but qt-xmlpatterns w/o exceptions
470 # 4.6: exceptions USE flag
471 local exceptions="-exceptions"
472 case "${PV}" in
473 4.5.*)
474 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
475 ;;
476 *)
477 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
478 ;;
479 esac
480
481 # note about -reduce-relocations:
482 # That flag seems to introduce major breakage to applications,
483 # mostly to be seen as a core dump with the message "QPixmap: Must
484 # construct a QApplication before a QPaintDevice" on Solaris
485 # -- Daniel Vergien
486 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
487
488 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
489 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
490 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
491 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
492 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
493 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
494 ${exceptions}
495 -nomake examples -nomake demos"
496
497 echo "${myconf}"
498}
499
500# @FUNCTION: build_directories 521# @FUNCTION: prepare_directories
501# @USAGE: < directories > 522# @USAGE: < directories >
523# @INTERNAL
502# @DESCRIPTION: 524# @DESCRIPTION:
503# Compiles the code in $QT4_TARGET_DIRECTORIES 525# Generates Makefiles for the given list of directories.
504build_directories() { 526prepare_directories() {
505 for x in "$@"; do 527 for x in "$@"; do
506 pushd "${S}"/${x} >/dev/null 528 pushd "${S}"/${x} >/dev/null || die
529 einfo "Running qmake in: ${x}"
507 # avoid running over the maximum argument number, bug #299810 530 # avoid running over the maximum argument number, bug #299810
508 { 531 {
509 echo "${S}"/mkspecs/common/*.conf 532 echo "${S}"/mkspecs/common/*.conf
510 find "${S}" -name '*.pr[io]' 533 find "${S}" -name '*.pr[io]'
511 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 534 } | xargs sed -i \
535 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
536 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
537 || die
512 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 538 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
539 popd >/dev/null || die
540 done
541}
542
543
544# @FUNCTION: build_directories
545# @USAGE: < directories >
546# @INTERNAL
547# @DESCRIPTION:
548# Compiles the code in the given list of directories.
549build_directories() {
550 for x in "$@"; do
551 pushd "${S}"/${x} >/dev/null || die
513 emake CC="$(tc-getCC)" \ 552 emake CC="$(tc-getCC)" \
514 CXX="$(tc-getCXX)" \ 553 CXX="$(tc-getCXX)" \
515 LINK="$(tc-getCXX)" || die "emake failed" 554 LINK="$(tc-getCXX)" || die "emake failed"
516 popd >/dev/null 555 popd >/dev/null || die
517 done 556 done
518} 557}
519 558
520# @FUNCTION: install_directories 559# @FUNCTION: install_directories
521# @USAGE: < directories > 560# @USAGE: < directories >
561# @INTERNAL
522# @DESCRIPTION: 562# @DESCRIPTION:
523# run emake install in the given directories, which are separated by spaces 563# Runs emake install in the given directories, which are separated by spaces.
524install_directories() { 564install_directories() {
525 for x in "$@"; do 565 for x in "$@"; do
526 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 566 pushd "${S}"/${x} >/dev/null || die
527 emake INSTALL_ROOT="${D}" install || die "emake install failed" 567 emake INSTALL_ROOT="${D}" install || die "emake install failed"
528 popd >/dev/null || die "Can't popd from ${S}/${x}" 568 popd >/dev/null || die
529 done 569 done
530} 570}
531 571
532# @ECLASS-VARIABLE: QCONFIG_ADD 572# @ECLASS-VARIABLE: QCONFIG_ADD
533# @DESCRIPTION: 573# @DESCRIPTION:
543# @DESCRIPTION: 583# @DESCRIPTION:
544# List variables that should be defined at the top of QtCore/qconfig.h 584# List variables that should be defined at the top of QtCore/qconfig.h
545: ${QCONFIG_DEFINE:=} 585: ${QCONFIG_DEFINE:=}
546 586
547# @FUNCTION: install_qconfigs 587# @FUNCTION: install_qconfigs
588# @INTERNAL
589# @DESCRIPTION:
548# @DESCRIPTION: Install gentoo-specific mkspecs configurations 590# Install gentoo-specific mkspecs configurations.
549install_qconfigs() { 591install_qconfigs() {
550 local x 592 local x
551 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 593 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
552 for x in QCONFIG_ADD QCONFIG_REMOVE; do 594 for x in QCONFIG_ADD QCONFIG_REMOVE; do
553 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 595 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
564 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 606 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
565 fi 607 fi
566} 608}
567 609
568# @FUNCTION: generate_qconfigs 610# @FUNCTION: generate_qconfigs
569# @DESCRIPTION: Generates gentoo-specific configurations 611# @INTERNAL
612# @DESCRIPTION:
613# Generates gentoo-specific qconfig.{h,pri}.
570generate_qconfigs() { 614generate_qconfigs() {
571 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 615 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then
572 local x qconfig_add qconfig_remove qconfig_new 616 local x qconfig_add qconfig_remove qconfig_new
573 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 617 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
574 [[ -f ${x} ]] || continue 618 [[ -f ${x} ]] || continue
588 632
589 # generate list of QT_CONFIG entries from the existing list 633 # generate list of QT_CONFIG entries from the existing list
590 # including qconfig_add and excluding qconfig_remove 634 # including qconfig_add and excluding qconfig_remove
591 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 635 for x in $(sed -n 's/^QT_CONFIG +=//p' \
592 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 636 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
593 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 637 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
594 done 638 done
595 639
596 # replace the existing QT_CONFIG list with qconfig_new 640 # replace the existing QT_CONFIG list with qconfig_new
597 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 641 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
598 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 642 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
622 fi 666 fi
623 fi 667 fi
624} 668}
625 669
626# @FUNCTION: qt4-build_pkg_postrm 670# @FUNCTION: qt4-build_pkg_postrm
671# @DESCRIPTION:
627# @DESCRIPTION: Generate configurations when the package is completely removed 672# Regenerate configuration when the package is completely removed.
628qt4-build_pkg_postrm() { 673qt4-build_pkg_postrm() {
629 generate_qconfigs 674 generate_qconfigs
630} 675}
631 676
632# @FUNCTION: qt4-build_pkg_postinst 677# @FUNCTION: qt4-build_pkg_postinst
678# @DESCRIPTION:
633# @DESCRIPTION: Generate configuration, plus throws a message about possible 679# Regenerate configuration, plus throw a message about possible
634# breakages and proposed solutions. 680# breakages and proposed solutions.
635qt4-build_pkg_postinst() { 681qt4-build_pkg_postinst() {
636 generate_qconfigs 682 generate_qconfigs
637} 683}
638 684
639# @FUNCTION: skip_qmake_build_patch 685# @FUNCTION: skip_qmake_build
686# @INTERNAL
640# @DESCRIPTION: 687# @DESCRIPTION:
641# Don't need to build qmake, as it's already installed from qt-core 688# Patches configure to skip qmake compilation, as it's already installed by qt-core.
642skip_qmake_build_patch() { 689skip_qmake_build() {
643 # Don't need to build qmake, as it's already installed from qt-core
644 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 690 sed -i -e "s:if true:if false:g" "${S}"/configure || die
645} 691}
646 692
647# @FUNCTION: skip_project_generation_patch 693# @FUNCTION: skip_project_generation
694# @INTERNAL
648# @DESCRIPTION: 695# @DESCRIPTION:
649# Exit the script early by throwing in an exit before all of the .pro files are scanned 696# Exit the script early by throwing in an exit before all of the .pro files are scanned.
650skip_project_generation_patch() { 697skip_project_generation() {
651 # Exit the script early by throwing in an exit before all of the .pro files are scanned
652 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 698 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
653 -i "${S}"/configure || die "Sed failed"
654} 699}
655 700
656# @FUNCTION: symlink_binaries_to_buildtree 701# @FUNCTION: symlink_binaries_to_buildtree
702# @INTERNAL
657# @DESCRIPTION: 703# @DESCRIPTION:
658# Symlink generated binaries to buildtree so they can be used during compilation 704# Symlinks generated binaries to buildtree, so they can be used during compilation time.
659# time
660symlink_binaries_to_buildtree() { 705symlink_binaries_to_buildtree() {
661 for bin in qmake moc uic rcc; do 706 for bin in qmake moc uic rcc; do
662 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 707 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
663 done 708 done
664} 709}
665 710
666# @FUNCTION: fix_library_files 711# @FUNCTION: fix_library_files
712# @INTERNAL
667# @DESCRIPTION: 713# @DESCRIPTION:
668# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 714# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
669# moves the *.pc-files into the pkgconfig directory 715# moves the *.pc files into the pkgconfig directory.
670fix_library_files() { 716fix_library_files() {
717 local libfile
671 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 718 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
672 if [[ -e ${libfile} ]]; then 719 if [[ -e ${libfile} ]]; then
673 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 720 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
674 fi 721 fi
675 done 722 done
676 723
677 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 724 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
678 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 725 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
679 if [[ -e ${libfile} ]]; then 726 if [[ -e ${libfile} ]]; then
680 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 727 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
681 728
682 # Move .pc files into the pkgconfig directory 729 # Move .pc files into the pkgconfig directory
683 dodir ${QTPCDIR#${EPREFIX}} 730 dodir ${QTPCDIR#${EPREFIX}}
684 mv ${libfile} "${D}"/${QTPCDIR}/ \ 731 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
685 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
686 fi 732 fi
687 done 733 done
688 734
689 # Don't install an empty directory 735 # Don't install an empty directory
690 rmdir "${D}"/${QTLIBDIR}/pkgconfig 736 rmdir "${D}"/${QTLIBDIR}/pkgconfig
691} 737}
692 738
693# @FUNCTION: qt_use 739# @FUNCTION: qt_use
694# @USAGE: < flag > [ feature ] [ enableval ] 740# @USAGE: < flag > [ feature ] [ enableval ]
695# @DESCRIPTION: 741# @DESCRIPTION:
696# This will echo "${enableval}-${feature}" if <flag> is enabled, or 742# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
697# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 743# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
698# will be used for that. If [enableval] is not specified, it omits the 744# will be used for that. If [enableval] is not specified, it omits the
699# assignment-part 745# "-${enableval}" part.
700qt_use() { 746qt_use() {
701 local flag=$1 747 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
702 local feature=$1
703 local enableval=
704
705 [[ -n $2 ]] && feature=$2
706 [[ -n $3 ]] && enableval=-$3
707
708 if use ${flag}; then
709 echo "${enableval}-${feature}"
710 else
711 echo "-no-${feature}"
712 fi
713} 748}
714 749
715# @FUNCTION: qt_mkspecs_dir 750# @FUNCTION: qt_mkspecs_dir
716# @RETURN: the specs-directory w/o path 751# @RETURN: the specs-directory w/o path
717# @DESCRIPTION: 752# @DESCRIPTION:
718# Allows us to define which mkspecs dir we want to use. 753# Allows us to define which mkspecs dir we want to use.
719qt_mkspecs_dir() { 754qt_mkspecs_dir() {
720 # Allows us to define which mkspecs dir we want to use.
721 local spec 755 local spec=
722 756
723 case ${CHOST} in 757 case "${CHOST}" in
724 *-freebsd*|*-dragonfly*) 758 *-freebsd*|*-dragonfly*)
725 spec=freebsd ;; 759 spec=freebsd ;;
726 *-openbsd*) 760 *-openbsd*)
727 spec=openbsd ;; 761 spec=openbsd ;;
728 *-netbsd*) 762 *-netbsd*)
739 *-solaris*) 773 *-solaris*)
740 spec=solaris ;; 774 spec=solaris ;;
741 *-linux-*|*-linux) 775 *-linux-*|*-linux)
742 spec=linux ;; 776 spec=linux ;;
743 *) 777 *)
744 die "Unknown CHOST, no platform choosen." 778 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
745 esac 779 esac
746 780
747 CXX=$(tc-getCXX) 781 case "$(tc-getCXX)" in
748 if [[ ${CXX} == *g++* ]]; then 782 *g++*)
749 spec+=-g++ 783 spec+=-g++ ;;
750 elif [[ ${CXX} == *icpc* ]]; then 784 *icpc*)
751 spec+=-icc 785 spec+=-icc ;;
752 else 786 *)
753 die "Unknown compiler ${CXX}." 787 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
754 fi 788 esac
755 if [[ -n ${LIBDIR/lib} ]]; then
756 spec+=-${LIBDIR/lib}
757 fi
758 789
759 # Add -64 for 64bit profiles 790 # Add -64 for 64bit profiles
760 if use x64-freebsd || 791 if use x64-freebsd ||
761 use amd64-linux || 792 use amd64-linux ||
762 use x64-macos || 793 use x64-macos ||
768 799
769 echo "${spec}" 800 echo "${spec}"
770} 801}
771 802
772# @FUNCTION: qt_assistant_cleanup 803# @FUNCTION: qt_assistant_cleanup
773# @RETURN: nothing 804# @INTERNAL
774# @DESCRIPTION: 805# @DESCRIPTION:
775# Tries to clean up tools.pro for qt-assistant ebuilds 806# Tries to clean up tools.pro for qt-assistant ebuilds.
776# Meant to be called in src_prepare 807# Meant to be called in src_prepare().
808# Since Qt 4.7.4 this function is a no-op.
777qt_assistant_cleanup() { 809qt_assistant_cleanup() {
810 # apply patching to qt-assistant ebuilds only
811 [[ ${PN} != "qt-assistant" ]] && return
812
813 # no longer needed for 4.7.4 and later
814 version_is_at_least "4.7.4" && return
815
778 # different versions (and branches...) may need different handling, 816 # different versions (and branches...) may need different handling,
779 # add a case if you need special handling 817 # add a case if you need special handling
780 case "${MY_PV_EXTRA}" in 818 case "${MY_PV_EXTRA}" in
781 *kde-qt*) 819 *kde-qt*)
782 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \ 820 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
791 ;; 829 ;;
792 esac 830 esac
793} 831}
794 832
795# @FUNCTION: qt_nolibx11 833# @FUNCTION: qt_nolibx11
796# @RETURN: nothing 834# @INTERNAL
797# @DESCRIPTION: 835# @DESCRIPTION:
798# Ignore X11 tests for packages that don't need X libraries installed 836# Ignore X11 tests for packages that don't need X libraries installed.
799qt_nolibx11() { 837qt_nolibx11() {
800 einfo "removing X11 check to allow X-less compilation"
801 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 838 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
802 die "x11 check sed failed" 839 die "x11 check sed failed"
803} 840}
804 841
805EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 842EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.86  
changed lines
  Added in v.1.122

  ViewVC Help
Powered by ViewVC 1.1.20